<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
<#assign httpPort = "8080">
<#if sysrun?? >
<#if sysrun.getPSDevSlnMSDepAPI()??>
    <#if sysrun.getPSDevSlnMSDepAPI().getHttpPort()??>
      <#assign httpPort = sysrun.getPSDevSlnMSDepAPI().getHttpPort()?c>
    </#if>
  </#if>
</#if>
server:
  port: ${httpPort}

<#if item.getAllPSAppDataEntities?? && app.getAllPSAppDataEntities()??>
#zuul网关路由设置
zuul:
  routes:
    <#assign haswfentity=false>
    <#list item.getAllPSAppDataEntities() as appDataEntity>
        <#assign serviceId="">
        <#assign serviceUrl=srfpluralize(appDataEntity.codeName?lower_case)>
        <#assign appEntity=appDataEntity.name?lower_case>
        <#assign psDataEntity=appDataEntity.getPSDataEntity()>
        <#assign systemName=sys.getCodeName()?lower_case>
        <#if psDataEntity.hasPSDEWF()??>
            <#assign haswfentity=true>
        </#if>
        <#if psDataEntity.getStorageMode()==4>
            <#comment>serviceApi模式</#comment>
            <#assign serviceId=(psDataEntity.getPSSubSysServiceAPI().getServiceCodeName())!''>
            <#assign serviceUrl=srfpluralize(appDataEntity.name?lower_case)>
      ${appEntity}:
        path: /${serviceUrl}/**
        serviceId: ${serviceId}
        stripPrefix: false
        </#if>
    </#list>
    <#if haswfentity==true>
      wfcore:
        path: /wfcore/**
        serviceId: ibzwf-api
        stripPrefix: false
    </#if>
    <#comment>通过设置该参数，避免Zuul转发请求时丢失Authorization请求头信息</#comment>
  sensitive-headers:
    - Cookie,Set-Cookie,Authorization
</#if>