<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
<#if de.getStorageMode()==1 || de.getStorageMode()==2 ||de.getStorageMode()==4||de.getStorageMode()==0>
package ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()};
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.filter.${de.getCodeName()}SearchContext;

<#comment>SQL存储-Mybatis</#comment>
<#if de.getStorageMode()==1>

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[${item.codeName}] 服务对象接口
 */
public interface I${item.codeName}Service extends IService<${item.codeName}>{

    <@addIDESerivceBody />

    List<JSONObject> select(String sql);
    boolean execute(String sql);

}
<#comment>NoSQL存储-MongoDB</#comment>
<#elseif de.getStorageMode()==2>

/**
 * 实体[${item.codeName}] 服务对象接口
 */
public interface I${item.codeName}Service{

    <@addIDESerivceBody />

}

<#elseif de.getStorageMode()==4>

/**
 * 实体[${item.codeName}] 服务对象接口
 */
public interface I${item.codeName}Service{

    <@addIDESerivceBody />

}

<#elseif de.getStorageMode()==0>

/**
 * 实体[${item.codeName}] 服务对象接口
 */
public interface I${item.codeName}Service{

    <@addIDESerivceBody />

}

</#if>

<#macro addIDESerivceBody >
<#comment>实体接口主体内容</#comment>
    <#assign keyfield=item.getKeyPSDEField()>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if deaction.isEnableBackend()>
                <#if (deaction.getActionType()=='USERCUSTOM') >
    ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} et) ;
                <#elseif deaction.getActionType()=='DELOGIC'>
    ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} et) ;
                <#elseif deaction.codeName?lower_case == 'get'>
    ${item.codeName} get(${srfjavatype(keyfield.stdDataType)} key) ;
                <#elseif deaction.codeName?lower_case == "create">
    boolean create(${item.codeName} et) ;
    void createBatch(List<${item.codeName}> list) ;
                <#elseif deaction.codeName?lower_case == "update">
    boolean update(${item.codeName} et) ;
    void updateBatch(List<${item.codeName}> list) ;
                <#elseif deaction.codeName?lower_case == "remove">
    boolean remove(${srfjavatype(keyfield.stdDataType)} key) ;
    void removeBatch(Collection<${srfjavatype(keyfield.stdDataType)}> idList) ;
                <#elseif deaction.codeName?lower_case == "save">
    boolean save(${item.codeName} et) ;
    void saveBatch(List<${item.codeName}> list) ;
                <#elseif deaction.codeName?lower_case == "getdraft">
    ${item.codeName} getDraft(${item.codeName} et) ;
                <#elseif deaction.codeName?lower_case == "checkkey">
    boolean checkKey(${item.codeName} et) ;
                <#elseif deaction.codeName?lower_case == "createbatch">
                <#elseif deaction.codeName?lower_case == "savebatch">
                <#elseif deaction.codeName?lower_case == "updatebatch">
                <#elseif deaction.codeName?lower_case == "removebatch">
                <#else>
    ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} et) ;
                </#if>
            </#if>
        </#list>
    </#if>
    <#if item.getAllPSDEDataSets()??>
        <#list item.getAllPSDEDataSets() as dedataset>
    Page<${item.codeName}> search${dedataset.getCodeName()}(${item.codeName}SearchContext context) ;
        </#list>
    </#if>

    <#comment>1：N关系中，在子实体中创建父实体的实例对象</#comment>
	<#if de.getMinorPSDERs?? && de.getMinorPSDERs()??>
		<#list de.getMinorPSDERs() as MinorPSDER>
			<#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>
				<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>
					<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
					<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >
						<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>
							<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>
							<#assign MajorField = MinorPSDER.getPSPickupDEField()>
							<#if de.getDefaultPSDEDataSet()??>
								<#assign deDefaultDataSet=de.getDefaultPSDEDataSet()>
								<#if deDefaultDataSet.getPSDEDataQueries()??>
    List<${item.getCodeName()}> selectBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) ;
    void removeBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case}) ;
	                                <#assign nested=MinorPSDER.isNestedRS()>
                                    <#if nested == false && MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs()??>
                                        <#list MinorPSDER.getMinorPSDataEntity().getAllPSDEServiceAPIs() as api>
                                            <#if api.isNested()>
                                                <#assign nested=true>
                                            </#if>
                                        </#list>
                                    </#if>
                                    <#if nested>
    void saveBy${srfcaseformat(MajorField.codeName,'l_u2lC')?cap_first}(${srfjavatype(MajorField.stdDataType)} ${MajorkeyField.codeName?lower_case},List<${item.getCodeName()}> list) ;
                                    </#if>

								</#if>
							</#if>
						</#if>
					</#if>
				</#if>
			</#if>
		</#list>
	</#if>

</#macro>

</#if>